﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using Telerik.WinControls;
using Telerik.WinControls.Layouts;
using Telerik.WinControls.Primitives;
using Telerik.WinControls.UI;

namespace _708167_BubbleBar
{
    [Browsable(true)]
    public class BubbleBarElement : RadElement
    {

        private FillPrimitive fill;
        private BorderPrimitive border;
        private StackLayoutPanel panel;

        private RadItemOwnerCollection items_Renamed;
        public BubbleBarElement()
        {
        }

        protected override void InitializeFields()
        {
            base.InitializeFields();
            this.Shape = new RoundRectShape(12);
            this.items_Renamed = new RadItemOwnerCollection();
            this.items_Renamed.ItemTypes = new Type[] { typeof(RadButtonElement) };
            items_Renamed.ItemsChanged += items_ItemsChanged;
        }

        public RadItemOwnerCollection Items
        {
            get { return items_Renamed; }
        }

        protected override void CreateChildElements()
        {
            fill = new FillPrimitive();
            fill.BackColor = Color.FromArgb(253, 253, 253);
            fill.BackColor2 = Color.FromArgb(112, 112, 112);
            fill.NumberOfColors = 2;
            fill.GradientStyle = GradientStyles.Linear;
            fill.GradientAngle = 90;
            fill.AutoSizeMode = RadAutoSizeMode.FitToAvailableSize;
            this.Children.Add(fill);
            border = new BorderPrimitive();
            border.GradientStyle = GradientStyles.Solid;
            border.ForeColor = Color.FromArgb(0, 0, 0);
            border.AutoSizeMode = RadAutoSizeMode.FitToAvailableSize;
            this.Children.Add(border);
            panel = new StackLayoutPanel();
            panel.Orientation = System.Windows.Forms.Orientation.Horizontal;
            //panel.Margin = new System.Windows.Forms.Padding(0, 20, 10, 0);      
            panel.Alignment = ContentAlignment.MiddleCenter;
            panel.StretchHorizontally = false;
            this.Children.Add(panel);
            this.items_Renamed.Owner = panel;
        }

        private void items_ItemsChanged(RadItemCollection changed, RadItem target, ItemsChangeOperation operation)
        {
            if (operation == ItemsChangeOperation.Inserted || operation == ItemsChangeOperation.Set)
            {
                target.AddBehavior(new BubbleBarMouseOverBehavior());
            }
        }

    }
}
